Bug 784608 - Review Request: kdevelop-custom-buildsystem - Support for custom buildsystem in KDevelop
Review Request: kdevelop-custom-buildsystem - Support for custom buildsystem ...
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Gregor Tätzner
Fedora Extras Quality Assurance
:
Depends On:
Blocks: kde-reviews
  Show dependency treegraph
 
Reported: 2012-01-25 09:55 EST by Radek Novacek
Modified: 2016-11-30 19:30 EST (History)
7 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-07-26 08:22:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
gregor: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Radek Novacek 2012-01-25 09:55:57 EST
Spec URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem.spec
SRPM URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem-1.2.1-1.fc16.src.rpm
Description: 
This plugin allows to handle arbitrary custom buildsystems with KDevelop.

It supports setting up commands and arguments to build, configure, clean,
'dist-clean' and install the project, so that KDevelop's actions work as
expected.
Comment 1 Volker Fröhlich 2012-02-13 17:36:49 EST
rm -rf $RPM_BUILD_ROOT is no longer necessary.

This package will only build on F17 and up, looking at the version requirements. You don't need to state a version for kdelibs-devel, since it is newer than 4.5 for any version of Fedora.

Can you make use of the tests?

Desktop files must be validated, please see:

http://fedoraproject.org/wiki/Packaging:Guidelines#desktop-file-install_usage

And for the sake of beauty, there's an empty line at the very bottom. ;)
Comment 2 Kevin Kofler 2012-02-13 18:00:39 EST
Given the path they're installed to, those .desktop files will only ever be read by kdelibs, so they need to be valid only for kdelibs.
Comment 3 Radek Novacek 2012-02-22 08:09:40 EST
Spec URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem.spec
SRPM URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem-1.2.1-2.fc16.src.rpm

* Wed Feb 15 2012 Radek Novacek <rnovacek@redhat.com> 1.2.1-2
- Remove unnecessary buildroot clean
- Remove dep version on kdelibs
- Validate desktop files

Both desktop files are valid, so I added the checking even if it's not necessary.

The tests can't be ran during the build of the package, because they require X server to be running (they creates QApplication).
Comment 4 nucleo 2012-03-07 22:09:17 EST
.desktop files have Type=Service, no Categories there but link to desktop-entry-spec in guidelines points to Type=Application,Link and Directory
http://standards.freedesktop.org/desktop-entry-spec/desktop-entry-spec-latest.html

So, running desktop-file-validate not required. It is needed for .desktop files installed in %{_datadir}/applications.
Comment 5 Gregor Tätzner 2012-04-07 07:22:41 EDT
The source url is not valid any more. Can you update it?
Comment 6 Radek Novacek 2012-04-13 07:27:19 EDT
Spec URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem.spec
SRPM URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem-1.2.1-3.fc17.src.rpm


* Fri Apr 13 2012 Radek Novacek <rnovacek@redhat.com> 1.2.1-3
- Update source url to match stable release
- Require stable version kdevelop 4.3.0

Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=3987507
Comment 7 Gregor Tätzner 2012-04-13 16:33:17 EDT
 - please use global instead of define at the top
http://fedoraproject.org/wiki/Packaging/Guidelines#.25global_preferred_over_.25define

and more important: How does this plugin work, actually? I can't see anything (besides cmake, make) in the project configuration. I'm on f16 kdevelop 4.3 kde 4.8.2
Comment 8 Gregor Tätzner 2012-07-21 04:09:54 EDT
@Radek Are you still interested in this package?
Comment 9 Radek Novacek 2012-07-23 02:57:12 EDT
Sorry, I forgot about this review completely. Yes, I'm interested, let's finish it.

Spec URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem.spec
SRPM URL: http://rnovacek.fedorapeople.org/kdevelop-custom-buildsystem-1.2.1-4.fc17.src.rpm

How does this plugin work:

When you are opening directory as a project, you can choose "Custom BuildSystem" as a build system. Then in project configuration you can specify which command will be executed in which phase (build, configure, install, clean, prune) and manually specify includes/imports.
Comment 10 Gregor Tätzner 2012-07-26 03:23:35 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.
     Note: Unversioned so-files in non-devel package (fix or explain
     ):kdevelop-custom-buildsystem-1.2.1-4.fc17.x86_64.rpm :
     /usr/lib64/kde4/kcm_kdevcustombuildsystem.so kdevelop-custom-
     buildsystem-1.2.1-4.fc17.x86_64.rpm :
     /usr/lib64/kde4/kdevcustombuildsystem.so


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Package installs a %{name}.desktop using desktop-file-install if
     there is such a file.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: MUST Useful -debuginfo package or justification otherwise.

== Approved ==

Note: upstream just released 1.2.2, but it's only suitable for kdevelop 4.4+
Comment 11 Radek Novacek 2012-07-26 03:40:29 EDT
New Package SCM Request
=======================
Package Name: kdevelop-custom-buildsystem
Short Description: Support for custom buildsystem in KDevelop
Owners: rnovacek
Branches: f17 f16
InitialCC:
Comment 12 Gwyn Ciesla 2012-07-26 06:29:01 EDT
Git done (by process-git-requests).
Comment 13 Radek Novacek 2012-07-26 08:22:59 EDT
Package is imported and built. Thanks everyone.

Note You need to log in before you can comment on or make changes to this bug.